<?php

require_once('Comm100LiveChat.class.php');

if( !class_exists( 'WP_Http' ) )
    include_once( ABSPATH . WPINC. '/class-http.php' );


final class Comm100LiveChatAdmin extends Comm100LiveChat
{
	/**
	 * Plugin's version
	 */
	protected $plugin_version = null;
    protected $show_success = FALSE;
    protected $comm100_url = "https://dash11.comm100.io/cmsui/integrationcms/index";
	protected $comm100_healthCheckurl=null;
    protected $current_user =null;

	public function getCurrentUser(){
	  $this->current_user = wp_get_current_user();
	}
	
	/**
	 * Create health check endpoint
	 */
	public function getHealthCheckURL()
	{
	if(strpos(get_option('comm100livechat_cpanel_domain'), 'https') !== false)
			$this->comm100_healthCheckurl = get_option('comm100livechat_cpanel_domain') . $this->get_platformhealthurl();
				elseif (get_option('comm100livechat_cpanel_domain') != false)
			$this->comm100_healthCheckurl = "https://" . get_option('comm100livechat_cpanel_domain') . $this->get_platformhealthurl();
            	
		return $this->comm100_healthCheckurl; 
}
	/**
	 * Create the URL to be displyed in iframe source
	 */
	public function getURL()
	{
	if(urldecode($this->get_email())!='') // after first login this will always be there
			{	
				if(strpos(get_option('comm100livechat_cpanel_domain'), 'https') !== false)
				$this->comm100_url = get_option('comm100livechat_cpanel_domain') . $this->get_platformurl() . $this->get_site_id() . "&codePlanId=" . $this->get_plan_id() . "&siteURL=" . urlencode(get_site_url()) . "&planType=" . $this->get_plan_type() . "&adminEmail=" . urlencode($this->get_email()) . "&ingtid=". $this->get_integration_id() ."&pn=" . $this->get_plan_name() ."&cpn=" . $this->get_code_planname();
				else
				$this->comm100_url = "https://" . get_option('comm100livechat_cpanel_domain') . $this->get_platformurl() . $this->get_site_id() . "&codePlanId=" . $this->get_plan_id() . "&siteURL=" . urlencode(get_site_url()) . "&planType=" . $this->get_plan_type() . "&adminEmail=" . urlencode($this->get_email()) . "&ingtid=". $this->get_integration_id() ."&pn=" . $this->get_plan_name() ."&cpn=" . $this->get_code_planname();
            }	
		else
			{
				$this->comm100_url .= "?adminEmail=" . $this->current_user->user_email . "&siteURL=" . get_site_url()  . "&ingtid=". $this->get_integration_id();
			}
		return $this->comm100_url; 
}
public function get_platformurl()
{
	if(urldecode($this->get_email())!='' && $this->get_platform()=='')
	{		
		return "/wordpressapp/wordpress/default?site=";
	}
	else
	{
		return "/cmsui/integrationcms/index?site=";
	}
}
public function get_platformhealthurl()
{
	if(urldecode($this->get_email())!='' && $this->get_platform()=='')
	{		
		return "/wordpressapp/";
	}
	else
	{
		return "/cmsui/integrationcms/health/";
	}
}
 //Register activation hook 
    public static function plugin_activation() {
		
			update_option( 'Activated_Comm100_Plugin_Redirect', true );
		
	}
	public function admin_init() {
		if ( get_option( 'Activated_Comm100_Plugin_Redirect' ) ) {
			delete_option('Activated_Comm100_Plugin_Redirect');
			if ( ! headers_sent() ) {
				exit(wp_redirect( add_query_arg( array( 'page' => 'comm100livechat_settings'), admin_url( 'admin.php' )) ));
			}
		}
	}
	/**
	 * Starts the plugin
	 */
	protected function __construct() {
		parent::__construct();
		
		add_action( 'admin_init', array( $this, 'admin_init' ));
		add_action('init', array($this, 'getCurrentUser'));

		add_action('admin_menu', array($this, 'admin_menu'));

		//$show_success = TRUE;
                //$this->email_send = get_current_user();
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (isset($_POST['site_id'])) {
				$this->update_site_id($_POST['site_id']);
				$this->update_email($_POST['email']); 
				$this->update_plan_id($_POST['plan_id']);
				$this->update_plan_type($_POST['plan_type']);				
				$this->update_cpanel_domain($_POST['cpanel_domain']);
				$this->update_plan_name($_POST['plan_name']);
				$this->update_code_planname($_POST['codeplan_name']);
				$this->update_platform($_POST['platform']);				
				$show_success = TRUE;
				echo "Done" ;
				exit;
			}
		} else {
			if (isset($_GET['reset'])) {
				$this->reset_options();
				$url = admin_url('admin.php'). "?page=comm100livechat&show_success=true"; 
				header("Location:" . $url);
			}
		}
	}

	public static function get_instance()
	{
		if (!isset(self::$instance))
		{
			$c = __CLASS__;
			self::$instance = new $c;
		}

		return self::$instance;
	}


	/**
	 * Set error reporting for debugging purposes
	 */
	public function error_reporting()
	{
		error_reporting(E_ALL & ~E_USER_NOTICE);
	}

	/**
	 * Returns this plugin's version
	 *
	 * @return string
	 */
	public function get_plugin_version()
	{
		if (is_null($this->plugin_version))
		{
			if (!function_exists('get_plugins'))
			{
				require_once(ABSPATH.'wp-admin/includes/plugin.php');
			}

			$plugin_folder = get_plugins('/'.plugin_basename(dirname(__FILE__).'/..'));
			$this->plugin_version = $plugin_folder['comm100livechat.php']['Version'];
		}

		return $this->plugin_version;
	}

	public function admin_menu()
	{
		add_menu_page(
			'Live Chat',
			'Live Chat',
			'administrator',
			'comm100livechat',
			array($this, 'livechat_settings_page'),
			$this->get_plugin_url().'/images/favicon.png?v20150722'
		);

		add_submenu_page(
			'comm100livechat',
			'Account Setup',
			'Account Setup',
			'administrator',
			'comm100livechat_settings',
			array($this, 'livechat_settings_page')
		);

		// remove the submenu that is automatically added
		if (function_exists('remove_submenu_page'))
		{
			remove_submenu_page('comm100livechat', 'comm100livechat');
		}

		// Settings link
		add_filter('plugin_action_links', array($this, 'livechat_settings_link'), 10, 2);
	}

	private function get_post_data($key) {
		return isset($_POST[$key]) ? $_POST[$key] : '';
	}


	/**
	 * Displays settings page
	 */
	public function livechat_settings_page()
	{
		$base = Comm100LiveChat::get_instance()->get_plugin_url();

		$site_id = $this->get_site_id();
		$cpanel_domain = $this->cpanel_domain;
		if(isset($_GET['siteId']))
		$query_site_id = $_GET['siteId'];
			else
	    $query_site_id='';
		if(isset($_GET['email']))
		$query_email = $_GET['email'];
			else
		$query_email = '';
		
	?>
		<script type="text/javascript">
			var comm100_cpanel_domain = "<?php echo $cpanel_domain ?>";
			var x = "<?php echo $this->getHealthCheckURL()?>";
			

jQuery.ajax({
                    type: 'POST',
                    url: "<?php echo $this->getHealthCheckURL()?>",
                    success: function(data){
                     
                    },
	error: function(xhr, status, error)
	{		
		jQuery('#Reset').show();
	}
                });
		</script>
		<script type="text/javascript" src="<?php echo $base ?>/js/plugin.js?v=20190725">
		</script>


		<div class="wrap">
	
 <iframe class="postbox" width="100%" height="850px" scrolling="yes" src="<?php echo $this->getURL()?>" 
 frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" 
 allowfullscreen style="overflow:hidden;border:none;"></iframe>
 <p id="Reset" style="color: #999;font-size: smaller;margin-top: -15px; display:none;">
                    Something went wrong? <a style="color: #0077cc;" href="?page=comm100livechat_settings&amp;reset=1" 
                    onclick="if (!confirm('Are you sure you wish to reset your account?'))return false;">Reset your account</a>.
                </p>
 	     				<script type="text/javascript">
					if (window.addEventListener) {
    window.addEventListener("message", onMessage, false);        
} else if (window.attachEvent) {
    window.attachEvent("onmessage", onMessage, false);
}

function onMessage(event) {
    

    var data = event.data;      
    if (typeof(window[data.func]) == "function") {
        window[data.func].call(null, data.message);
    }
}

// Function to be called from iframe
function callBackFromIFrame(responseObject) {
	try
	{
	var parsedJSON = JSON.parse(responseObject);
	if(parsedJSON.action==="sync")
	{
		
		var formData = {
			'site_id': parsedJSON.comm100livechat_site_id,
			'email': parsedJSON.comm100livechat_email,
			'plan_id': parsedJSON.comm100livechat_plan_id,
			'plan_type': parsedJSON.comm100livechat_plan_type,
			'code': '',
			'status': "true",
			'cpanel_domain': parsedJSON.comm100livechat_cpanel_domain,
			'plan_name':parsedJSON.plan_name,
			'codeplan_name':parsedJSON.codeplan_name,
			'platform':parsedJSON.comm100livechat_platform
		};
		
		
		var plan = parsedJSON.comm100livechat_plan_id;
		
	     						if ((plan == '0') || (plan == '')) {
	     							alert('Please select a code plan.');
	     							return false;
	     						}
		jQuery.ajax({
                    type: 'POST',
                    url: "<?php echo admin_url('admin.php'); ?>" + "?page=comm100livechat&show_success=true",
                    data: formData,               
                    success: function(data){
                     
                    }
                });
		
	    
	}
	else if(parsedJSON.action==="reset")
	{
		window.location.href="?page=comm100livechat_settings&reset=1";
	}
	else if(parsedJSON.action==="activate")
	{
		window.location.href='widgets.php';
	}
	}
	catch(e)
	{
		 console.log('Unexpected error. Please have a live chat with our support team or email to support@comm100.com.');
	}
}
</script>

		
		</div>
<?php
	}

	/**
	 * Displays control panel page
	 */
	public function control_panel_page()
	{
		$site_id = $this->get_site_id();
		$cpanel_domain = $this->get_cpanel_domain();
        
		$base = Comm100LiveChat::get_instance()->get_plugin_url();

		echo <<<HTML
		    <script type="text/javascript" src="{$base}/js/page.js?20190725">
		    </script>
			<iframe id="control_panel" src="https://secure.comm100.com/login.aspx" frameborder="0" width="100%" height="700"></iframe>
			<div>You may also <a href="https://secure.comm100.com/login.aspx" target="_blank">access the Control Panel in a new window</a>.</div>
HTML;
	}
    
	public function visitor_monitor_page()
	{
		$site_id = $this->get_site_id();
		$cpanel_url = 'https://' . $this->get_cpanel_domain() . '/livechat/visitormonitor.aspx';
        if ($site_id > 0)
            $cpanel_url = $cpanel_url . '?siteId=' . $site_id;
            
		$base = Comm100LiveChat::get_instance()->get_plugin_url();

		echo <<<HTML
		    <script type="text/javascript" src="{$base}/js/page.js?20190725">
		    </script>
			<iframe id="control_panel" src="{$cpanel_url}" frameborder="0" width="100%" height="700" style="margin:10px 0 0px 0"></iframe>
			<div>You may also <a href="{$cpanel_url}" target="_blank">get online and chat in a new window</a>.</div>
HTML;
	}

	public function livechat_settings_link($links, $file)
	{
		if (basename($file) !== 'comm100livechat.php')
		{
			return $links;
		}

		$settings_link = sprintf('<a href="admin.php?page=comm100livechat_settings">%s</a>', __('Settings'));
		array_unshift ($links, $settings_link); 
		return $links;
	}


	protected function reset_options()
	{
		delete_option('comm100livechat_site_id');
		$this->site_id = 0;
		delete_option('comm100livechat_email');
		$this->email = '';
		delete_option('comm100livechat_code');
		$this->code = '';
		delete_option('comm100livechat_plan_id');
		$this->plan_id = '';
		delete_option('comm100livechat_plan_type');
		$this->plan_type = 0;
		delete_option('comm100livechat_cpanel_domain');
		$this->cpanel_domain = '';
		delete_option('comm100livechat_main_chatserver_domain');
		delete_option('comm100livechat_standby_chatserver_domain');
		$this->plan_name = '';
		delete_option('comm100livechat_plan_name');
		$this->codeplan_name = '';
		delete_option('comm100livechat_codeplan_name');		
		$this->platform = '';
		delete_option('comm100livechat_platform');	
		
	}

	protected function update_cpanel_domain($cpanel_domain) 
	{
		update_option('comm100livechat_cpanel_domain', $cpanel_domain);
		$this->cpanel_domain = $cpanel_domain;
	}
	
	protected function update_site_id($site_id)
	{
		update_option('comm100livechat_site_id', $site_id);
		$this->site_id = $site_id;
	}
	protected function update_email($email)
	{
		update_option('comm100livechat_email', $email);
		$this->email = $email;
	}
	protected function update_code($code)
	{
		update_option('comm100livechat_code', $code);
		$this->code = $code;
	}
	protected function update_plan_id($plan_id)
	{
		update_option('comm100livechat_plan_id', $plan_id);
		$this->plan_id = $plan_id;
	}
	protected function update_plan_type($plan_type)
	{
		update_option('comm100livechat_plan_type', $plan_type);
		$this->plan_type = $plan_type;
	}
	protected function update_plan_name($plan_name)
	{
		update_option('comm100livechat_plan_name', $plan_name);
		$this->plan_name = $plan_name;
	}
	protected function update_code_planname($codeplan_name)
	{
		update_option('comm100livechat_codeplan_name', $codeplan_name);
		$this->codeplan_name = $codeplan_name;
	}	
	protected function update_platform($platform)
	{
		update_option('comm100livechat_platform', $platform);
		$this->platform = $platform;
	}	
	
}